Add an animated typing indicator to your Vue chat app

Last updated
November 3, 2019
by
A tech enthusiast, programming freak and a web development junkie who loves to embrace new technology.

Olususi Oluyemi

Most chat applications need a typing indicator and in this tutorial, you'll learn how code your own. “Someone is typing” indicators are a handy communication tool.

Add an animated typing indicator to your Vue chat app

Table of Contents

    Most chat applications need a typing indicator and in this tutorial, you'll learn how code your own.

    “Someone is typing” indicators are a handy communication tool. If you know someone is there on the other end writing, you might stick around a bit longer to see their response. The fact that typing indicators update in real-time makes users feel connected in such a way they will probably spend more time typing on your app.

    It’s a little-known fact that typing indicators in the real-world are actually a little bit wonky:

    In this example from The Journal, the indicator only disappears 60 seconds after you started the text.

    While knowing that someone is typing can be helpful, sticking around to see what they typed when they weren’t even typing is the first place is just annoying. In this tutorial, we will be using CometChat Pro which ensures real-time updates are nearly instant. We’ll also be adding a slick animated typing indicator to give users something nice to look at.

    Chat window with typing indicator

    In this case, when Iron Man (a made up test user) is typing, other participants in the group can see that “Iron man is typing”. Of course, you could apply the same logic to a one-on-one conversation too.

    I encourage you to follow along as you’re bound to learn something new but if you’d just like the source code, you can find the example Vue chat code here.

    Getting started

    In the past, I wrote about how to build a group chat with Vue and uploaded the complete code to GitHub.  Rather than start from absolute scratch, in this short tutorial, I am going to extend the previous application.

    I also wrote about building a one on one chat with Vue and, while I won’t mention it again in this tutorial, you could well apply the same logic to one-on-one conversations.

    With that out of the way, step one is to clone the starter template I made based on the previous tutorial:

    {% c-line %} git clone https://github.com/cometchat-pro-tutorials/vue-typing-indicators.git{% c-line-end %}

    This project contains a couple of required dependencies that you will need to install, the image assets specifically for this project, and a stylesheet to give the app an appealing look. So, once the installation process is complete, navigate to the project directory and install all the dependencies:

    {% c-block %}
    // change directory
    cd vue-typing-indicators
    {% c-block-end %}

    {% c-block %}
    // install dependencies
    npm install
    {% c-block-end %}

    The preceding command will install the CometChat JavaScript SDK for this project (@cometchat-pro/chat ) and other Vue specific packages.

    What is CometChat

    Having mentioned CometChat a couple of times in the sections above, you are probably wondering what it is. CometChat is a service built in form of robust SDK and API. It was designed as a developer tool to help save hours of development whenever you need to add a chat feature to your application. With CometChat, you can also easily access other power packed suite of chat features such as One-on-One chat, group chat, voice and video and so on. More information can be found here on our official website.

    Create a free CometChat account

    To have access to all the functionalities offered by CometChat through its JavaScript SDK, you will need to create a free CometChat Pro account. Fill in all the required information and you will have a trial account set up for you. Then, head to your CometChat dashboard, add a new app by selecting v1 from the dropdown and enter the desired name for your app. Proceed to click on the + sign and wait for a couple of seconds for your new app to be created.

    Once this is done, you will be redirected back to the initial page where your new app will be listed. Click the Explore button and then go to the API Keys tab. Copy and save both your APP ID and the API Key with fullAccess scope that was automatically generated for your application, somewhere, as you will need it later.

    You are now equipped with the appropriate credentials required to communicate with CometChat server through the use of the JavaScript SDK. We will utilize the credentials created here to run our chat application in the next section.

    Run the group chat application

    With the starter project downloaded from GitHub, let’s run the application and ensure that it is functioning as a group chat application at the moment. Before that, create a new file named .env  within the root directory of the application and add the following code to it:

    {% c-block %}
    // .env
    VUE_APP_COMMETCHAT_API_KEY=YOUR_API_KEY                
    VUE_APP_COMMETCHAT_APP_ID=YOUR_APP_ID
    VUE_APP_COMMETCHAT_GUID=YOUR_GROUP_GUID
    {% c-block-end %}

    This is an environment configuration file where we will define environment variables with the values of our CometChat account credentials. Ensure that you replace YOUR_API_KEY, YOUR_APP_ID, and YOUR_GROUP_GUID placeholder with the appropriate values as obtained from your CometChat dashboard.

    Next, while you are still within the vue-typing-indicator project directory, run the following command to start the application:

    {% c-line %} npm run serve {% c-line-end %}

    Navigate to the http://localhost:8080 and enter any of the test users (i.e superhero1 , superhero2, superhero3 ) to start a chat:

    You can now type a message to start a chat. Of course, the chat history will be empty at the moment:

    Feel free to open another window and login with another user and then proceed to send messages to the group. If everything works properly, you now have a functioning group chat and in the next section, we will start implementing the typing indicator as mentioned earlier.

    Add typing indicators

    What we want to achieve here is pretty straight forward. Once a user starts typing, we want to grab the username of such an authenticated user and show an animated typing indicator to indicate that such a user is currently typing. For the typing animation, we will use the code from the awesome pen created by Jimmy Yoon.

    Start typing
    To check if a user has started typing we will use @keyup to listen for keyboard events within the input field and then notify CometChat by calling the method startTyping()  within the TypingIndicator  class from CometChat SDK. To begin, navigate to the src/views folder and open the Chat.vue file. Once you are done, scroll down to the <script></script> section and include the method named startTypingEvent() immediately after the sendGroupMessage() function:

    {% c-block language="javascript" %}
    // ./src/views/Chat.vue
    <template>
    ...
    </template>
    <script>
     ...
     methods: {
       ...
       sendGroupMessage() {
       ...
       },
       // add startTypingEvent method
       startTypingEvent() {
         let receiverId = process.env.VUE_APP_COMMETCHAT_GUID;
         let receiverType = CometChat.RECEIVER_TYPE.GROUP;

         let typingNotification = new CometChat.TypingIndicator(
           receiverId,
           receiverType
         );
         CometChat.startTyping(typingNotification);      
       }    
     }
    };
    </script>
    {% c-block-end %}

    From the new method defined above, we passed the receiverId  and the receiverType to the TypingIndicator class. This will ensure that the typing indicator’s notification is sent to the right receiver, which is a group with the specified GUID. This group will now be able to listen and receive the information via the MessageListener class. More about that later in the tutorial.

    Next, locate the input field and add the @keyup=``"``startTypingEvent()``" to listen to the keyboard event on the input field and then call the startTypingEvent() method that was created earlier:

    {% c-block language="html" %}
    // ./src/views/Chat.vue
    <template>
    ...
    <div class="msg-bottom">
    <form class="message-form" v-on:submit.prevent="sendGroupMessage">
    <div class="input-group">
    <!-- Add typing event -->
    <input type="text" class="form-control message-input" @keyup="startTypingEvent()" placeholder="Type something" v-model="chatMessage" required>
    <spinner
               v-if="sendingMessage"
               class="sending-message-spinner"
               :size="30"
             />
    </div>
    </form>
    </div>
    ...
    </template>
    {% c-block-end %}

    Incoming typing indicator

    Since we have been able to send typing indicator information in the previous section, the next thing is for the application to receive the detailed information once a user starts or ends typing. The information can be received within the onTypingStarted() and onTypingEnded() method of the MessageListener class.

    To configure this, add a new data property named typingUsers[] within the data option as shown below. Also, immediately after the onTextMessageReceived()method within the message listener class, add two more methods named onTypingStarted() and onTypingEnded() and then update the contents as shown here:

    {% c-block language="javascript" %}
    // ./src/views/Chat.vue
    <script>
    ...
    export default {
     ...
     data() {
       return {
         ...
         // add typingUsers array
         typingUsers: []
       };
     },
     mounted() {
       ...
       CometChat.addMessageListener(
         listenerID,
         new CometChat.MessageListener({
           ...
           // add TypingStarted and TypingEnded
           onTypingStarted: typingIndicator => {
             console.log('Typing started :', typingIndicator);
             this.typingUsers.push(typingIndicator.sender);
           },
           onTypingEnded: typingIndicator => {
               console.log('Typing ended :', typingIndicator);
               this.typingUsers = this.typingUsers.filter(
                 user => user.uid !== typingIndicator.sender.uid
               );
           }
         })
       );
     },
     ...
    };
    </script>
    {% c-block-end %}


    Here, within the onTypingStarted()  method, we obtained the details of the user that is typing a message in form of an object and push it into the typingUsers[] property. Also, as soon as the user is done typing, we used the onTypingEnded()  method to update the list of users within the typingUsers[]  array by filtering the details of the currently authenticated user out of the array. This will ensure that the logged in user will not see his or her username while typing. Cool, right?

    Show username and animated indicator

    To show the username of the currently typing user update the <template></template> section of Chat.vue page with the following:

    {% c-block language="html" %}
    // ./src/views/Chat.vue
    <template>
    ...
    <div class="chat-page">
    <div class="msg-inbox">
         ...  
    <div>
    <div class="currently-typing-wrapper">
    <div>
    <p v-if="typingUsers.length === 1"> {{typingUsers[0].name}} is typing </p>
    <p v-else-if="typingUsers.length === 2"> {{typingUsers[0].name}} and  {{typingUsers[1].name}} are typing </p>
    <p v-else-if="typingUsers.length > 2"> Several people are typing</p>
    </div>
    <div class="container-dot" v-if="typingUsers.length > 0">
    <span class="dot"></span>
    <span class="dot"></span>
    <span class="dot"></span>
    </div>
    </div>
    </div>
         ...
    </div>
    </div>
    ...
    </template>
    {% c-block-end %}

    We conditionally rendered the username(s) of the users that are currently typing and also show the animated typing indicator. When more than two people are typing the application will show a message indicating that “Several people are typing”.  If you missed any of the steps, check here for the complete Chat.vue file for this application.

    Finally, update the stylesheet of this application in ./src/App.css by adding the following content:

    {% c-block language="javascript" %}
    // ./src/App.css
    ...
    /* include typing indicator style */
    .currently-typing-wrapper {
     background: #f8f9fb;
     padding: 12px;
     display: inline-flex;
     width: 100%;
     flex-direction: row;
     align-content: center;
     justify-items: center;
     height: 50px;
    }
    .container-dot {
     padding-left: 15px;
     display: inline-block;
    }
    .dot {
     height: 10px;
     width: 10px;
     border-radius: 100%;
     display: inline-block;
     background-color: #B4B5B9;
     animation: 1.2s typing-dot ease-in-out infinite;
    }
    .dot:nth-of-type(2) {
     animation-delay: 0.15s;
    }
    .dot:nth-of-type(3) {
     animation-delay: 0.25s;
    }
    @keyframes typing-dot {
     15% {
       transform: translateY(-35%);
       opacity: 0.5;
     }
     30% {
       transform: translateY(0%);
       opacity: 1;
     }
    }
    {% c-block-end %}

    Test the application

    Restart the application if it is not currently running by using the npm run serve command. Then navigate to http://localhost:8080 to view it

    Login
    Open the application in two separate windows and login with any two of the test users:
    superhero1, superhero2 or superhero3

    Type a message to view the indicator
    Once you can log in from both window, type a message and you will see the typing indicator showing the username of each user during the process:

    Conclusion

    In this tutorial, you have been able to extend the chat functionality of a Vuejs group chat application by including an animated typing indicator. This new feature that you just implemented here will go a long way to boost the interactivity of your chat application.

    Feel free to check the complete source code here on the master branch of this repository and don’t forget to visit CometChat documentation for more features for your application and also check out other awesome comprehensive tutorials from our team.

    What to Read Next

    No items found.

Verbal communication is an essential part of human life. Today, technology brings the possibility of much richer communication channel then standard text-chat to our browsers. With CometChat you can build your audio and Video chat application on your website. Today you will integrate CometChat with Angular application.
There is a companion repository created for this post, available on the GitHub.
First things first. In the catalog where you want your project to be located, type in the following Angular CLI command, which creates Angular project boilerplate:
{% c-line %} ng new comet-chat-typing-indicator --style scss --routing true{% c-line-end %}
And install @cometchat-pro/chat library from npm:
{% c-line %} npm install @cometchat-pro/chat{% c-line-end %}
Customize the global stylesheet by editing src/styles.scss file and place there following content:
{% c-block language="html" %}
html {
height: 100%;
}
body {
background: #1B46D5;
font-family: 'Roboto', sans-serif;
height: 100%;
display: flex;
justify-content: center;
align-items: center;
}
{% c-block-end %}
Now navigate into just created file, and replace the content of the src/app/app.component.html file with following HTML syntax:
{% c-line %} <router-outlet></router-outlet>{% c-line-end %}
Add some styling to the src/app/app.component.scss file:
{% c-block language="html" %}
:host {
margin: 0 auto;
background: white;
width: calc(100% - 20px);
height: 500px;
max-width: 680px;
display: block;
border-radius: 6px;
}
{% c-block-end %}
Now it’s time to store your application ID and API Key in the environments/environment.ts file:
{% c-block %}
export const environment = {
production: false,
appId: 'Your app ID',
apiKey: 'Your API Key'
};
{% c-block-end %}
The application is going to have two main components: LoginComponent and ChatComponent.
ChatComponent is the place where a logged in user will be brought to display a group chat window. If the user is not authenticated, he needs to provide login and password in the LoginComponent. Information about user authentication will be provided by the CometChatService. Generate them using the following commands:
{% c-block %}
ng g c Login
ng g c Chat
ng g s CometChat
{% c-block-end %}
Let’s start from the implementation of the CometChatService functionalities. Replace the content of the src/app/comet-chat.service.ts file with the following code:
{% c-block language="javascript" %}
import { Injectable } from '@angular/core';
import { CometChat } from "@cometchat-pro/chat"
import { environment } from 'src/environments/environment';
import { Observable, ReplaySubject, Subject, from } from 'rxjs';
import { filter, flatMap, tap } from 'rxjs/operators';
@Injectable({
providedIn: 'root'
})
export class CometChatService {
private initialized: Subject<boolean> = new ReplaySubject();
private signedIn$: Subject<string> = new ReplaySubject();
private _signedIn: boolean = false;
constructor() {
CometChat.init(environment.appId).then(_ => {
console.log('Comet Chat initialized.');
this.initialized.next(true);
}, error => {
console.log('Initialization error: ' + error);
});
}
public login(uid: string): Observable<any> {
uid = uid.toLowerCase();
return this.initialized.pipe(filter(v => v), flatMap(() => {
return from(CometChat.login(uid, environment.apiKey)).pipe(tap((user: any) => {
this.signedIn$.next(uid);
this._signedIn = true;
}));
}));
}
public getSignedIn(): Observable<string> {
return this.signedIn$;
}
public isSignedIn(): boolean {
return this._signedIn;
}
}
{% c-block-end %}
With this basic functionality of the CometChatService (authenticating user and checking if he is authenticated) we can build up an AuthenticationGuard to protect the ChatComponent against unauthorized access. Generate the AuthenticationGuard:
{% c-line %} ng g g auth --implements CanActivate{% c-line-end %}
Now, you can implement the Authentication Guard which will check if user is authenticated every time he is trying to navigate into the application. Replace the content of the src/app/auth.guard.ts file with following code:
{% c-block language="javascript" %}
import { Injectable } from '@angular/core';
import { CanActivate, Router } from '@angular/router';
import { CometChatService } from './comet-chat.service';
@Injectable({
providedIn: 'root'
})
export class AuthGuard implements CanActivate {
constructor(private chat: CometChatService, private router: Router) {}
canActivate(): boolean {
if (!this.chat.isSignedIn()) {
this.router.navigate(['login']);
}
return this.chat.isSignedIn();
}
}
{% c-block-end %}
Now it’s more than ready to use it in the app navigation. Place following content in the src/app/app-routing.module.ts:
{% c-block language="javascript" %}
import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { LoginComponent } from './login/login.component';
import { ChatComponent } from './chat/chat.component';
import { AuthGuard } from './auth.guard';
const routes: Routes = [
{path: '', redirectTo: 'chat', pathMatch: 'full'},
{path: 'login', component: LoginComponent },
{path: 'chat', component: ChatComponent, canActivate: [AuthGuard]}
]
@NgModule({
imports: [ RouterModule.forRoot(routes) ],
exports: [RouterModule]
})
export class AppRoutingModule { }
{% c-block-end %}
Ok, let’s give the user ability to login. Paste following code representing login form, to the src/login/login.component.ts file:
{% c-block language="javascript" %}
import { Component } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { CometChatService } from '../comet-chat.service';
import { Router } from '@angular/router';
@Component({
selector: 'app-login',
templateUrl: './login.component.html',
styleUrls: ['./login.component.scss']
})
export class LoginComponent {
public loginForm = new FormGroup({
uid: new FormControl('', Validators.required)
});
constructor(private chat: CometChatService, private router: Router) {}
public signIn(): void {
this.chat.login(this.loginForm.value['uid']).subscribe(signedUser => {
this.router.navigate(['chat']);
});
}
}
{% c-block-end %}
And following HTML template in the src/app/login/login.component.html
{% c-block language="html" %}
<h1>Welcome Back</h1>
<p>To access this demo, you can use one of the following four users: superhero1, superhero2, superhero3, or superhero4</p>
<form [formGroup]="loginForm" (ngSubmit)="signIn()">
<input type="text" formControlName="uid" placeholder="Username" />
<button type="submit" [disabled]="!loginForm.valid">Log In</button>
</form>
{% c-block-end %}
You can also add some styling, to make it prettier. Paste following CSS into src/app/login/login.component.scss
{% c-block language="css" %}
:host {
color: #2D313F;
padding: 15px;
display: block;
}
input {
border: 1px solid #BBBEBE;
width: 50%;
height: 100%;
border-radius: 6px 6px 6px 6px;
font-size: 16px;
padding: 10px 29px;
outline: none;
box-shadow: none;
color: #2D313F;
}
input::placeholder {
color: #BBBEBE;
}
button {
background: #1B46D5;
border-radius: 6px 6px 6px 6px;
font-size: 16px;
padding: 10px 29px;
color: #ffffff;
margin-left: 10px;
text-transform: uppercase;
}
button:hover {
cursor: pointer;
}
{% c-block-end %}
The last thing to do in this step is to add a new import to the src/app/app.module.ts, in the imports array add ReactiveFormsModule, imported from the @angular/forms library:
{% c-block language="javascript" %}
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { LoginComponent } from './login/login.component';
import { ChatComponent } from './chat/chat.component';
import { ReactiveFormsModule } from '@angular/forms';
@NgModule({
declarations: [
AppComponent,
LoginComponent,
ChatComponent
],
imports: [
BrowserModule,
AppRoutingModule,
ReactiveFormsModule
],
providers: [],
bootstrap: [AppComponent]
})
export class AppModule { }
{% c-block-end %}
Now, after navigating to the localhost:4200, the login page should be displayed:
If you haven't been coding along and want to catch up to this step using the companion repository on GitHub, execute the following commands:
{% c-block %}
git clone https://github.com/maciejtreder/comet-chat-angular.git
cd comet-chat-angular
git checkout step1
npm install
{% c-block-end %}
Let’s start the implementation of the main functionality. First thing first, add a new fields to the src/app/comet-chat.service.ts:
{% c-block language="javascript" %}
private _whoIsTypingArr: string[] = [];
private messages$: Subject<any> = new ReplaySubject();
private actualImage: string;
private whoIsTyping$: Subject<string[]> = new BehaviorSubject([]);
{% c-block-end %}
Remember to add BehaviorSubject to the import statement from the rxjs library.
It’s time to add some CometChat listeners. We will do that at the moment when user is logging into the application. Replace the login method with following new implementation:
{% c-block language="javascript" %}
public login(uid: string): Observable<any> {
uid = uid.toLowerCase();
return this.initialized.pipe(filter(v => v), flatMap(() => {
return from(CometChat.login(uid, environment.apiKey)).pipe(tap((user: any) => {
this.signedIn$.next(uid);
this._signedIn = true;
this.actualImage = user.avatar;
CometChat.addMessageListener('messageListener', new CometChat.MessageListener({
onTextMessageReceived: message => {
this.messages$.next({name: message.sender.name, image: message.sender.avatar, message: message.text, arrived: uid !== message.sender.uid});
},
onTypingStarted: (who) => {
if(this._whoIsTypingArr.indexOf(who.sender.name) > -1)
return;
this._whoIsTypingArr.push(who.sender.name);
this.whoIsTyping$.next(this._whoIsTypingArr);
},
onTypingEnded: (who) => {
this._whoIsTypingArr.splice(this._whoIsTypingArr.findIndex(val => val === who.sender.name), 1);
this.whoIsTyping$.next(this._whoIsTypingArr);
}
}));
}));
}));
}
{% c-block-end %}
Implement methods which will be responsible for sending message to the group and retrieve messages in the component. For the purpose of that method you will use the CometChat library:
{% c-block language="javascript" %}
public sendMessage(content: string): void {
this.messages$.next({image: this.actualImage, message: content, arrived: false});
let message = new CometChat.TextMessage('supergroup', content, CometChat.MESSAGE_TYPE.TEXT, CometChat.RECEIVER_TYPE.GROUP);
CometChat.sendMessage(message).catch(console.log);
}
public getMessages(): Observable<any> {
return this.messages$;
}
{% c-block-end %}
Add also methods which will initialize typing, finish typing and publish to the component list of actually typing users:
{% c-block language="javascript" %}
public startTyping(): void {
CometChat.startTyping(new CometChat.TypingIndicator('supergroup', CometChat.RECEIVER_TYPE.GROUP, {}));
}
public endTyping(): void {
CometChat.endTyping(new CometChat.TypingIndicator('supergroup', CometChat.RECEIVER_TYPE.GROUP, {}));
}
public getTypingIndicator(): Observable<any> {
return this.whoIsTyping$;
}
{% c-block-end %}
Now you can consume the new implementation of the CometChatService in the ChatComponent and nested components. Replace the code inside src/app/chat/chat.component.ts with the following code:
{% c-block language="javascript" %}
import { Component } from '@angular/core';
import { CometChatService } from '../comet-chat.service';
import { Observable } from 'rxjs';
@Component({
selector: 'app-chat',
templateUrl: './chat.component.html',
styleUrls: ['./chat.component.scss']
})
export class ChatComponent {
public loggedIn: Observable<string> = this.chatService.getSignedIn();
constructor(private chatService: CometChatService) {}
}
{% c-block-end %}
Adjust the template, in the src/app/chat/chat.component.html:
{% c-block language="html" %}
<div>You are logged in as: {{loggedIn | async}}</div>
<app-chat-window></app-chat-window>
<app-message-box></app-message-box>
{% c-block-end %}
And add some styles in the src/app/chat/chat.component.scss:
{% c-block language="css" %}
a:hover {
cursor: pointer;
text-decoration: none;
}
a {
text-decoration: underline;
}
div {
padding: 0 28px;
font-size: 15px;
line-height: 18px;
display: flex;
align-items: center;
height: 61px;
color: #2D313F;
border-radius: 6px 6px 0 0;
background: #FFFFFE;
}
{% c-block-end %}
As you can see, we introduced two new components MessageBoxComponent and ChatWindowComponent. Generate them with the CLI by using following command:
{% c-block language="javascript" %}
ng g c chatWindow
ng g c messageBox
{% c-block-end %}
Start from implementing the MessageBoxComponent it would be responsible for sending typed message to the supergroup of superheroes. Replace the code inside src/app/message-box/message-box.component.ts with following
{% c-block language="javascript" %}
import { Component, OnInit } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { CometChatService } from '../comet-chat.service';
import { tap } from 'rxjs/operators';
import { Subject, BehaviorSubject } from 'rxjs';
@Component({
selector: 'app-message-box',
templateUrl: './message-box.component.html',
styleUrls: ['./message-box.component.scss']
})
export class MessageBoxComponent implements OnInit {
public messageForm = new FormGroup({
message: new FormControl('', Validators.required)
});
public touched: Subject<boolean> = new BehaviorSubject(false);
constructor(private chatService: CometChatService) { }
public send():void {
this.chatService.sendMessage(this.messageForm.value['message']);
this.chatService.endTyping();
this.messageForm.reset();
}
ngOnInit() {
this.messageForm.valueChanges.pipe(
tap(() => this.chatService.startTyping()),
).subscribe();
}
}
{% c-block-end %}
Whenever user will type something into the form described here, the startTyping method on the CometChatService will be fired and inform other users that something is going on.
Create template in src/app/message-box/message-box.component.html:
{% c-block language="html" %}
<form [formGroup]="messageForm" (ngSubmit)="send()">
<input [ngClass]="{'inactive': !(touched | async)}" type="text" formControlName="message" (focus)="onFocus()" placeholder="Type something" />
</form>
{% c-block-end %}
And add styling to the src/app/message-box/message-box.component.scss:
{% c-block language="html" %}
form {
height: 60px;
width: 100%;
display: flex;
}
input {
width: 100%;
height: 100%;
border: 0;
border-radius: 0 0 6px 6px;
font-size: 16px;
padding: 0 29px;
outline: none;
box-shadow: none;
color: #2D313F;
}
input::placeholder {
color: #BBBEBE;
}
{% c-block-end %}
Now add the last piece to our puzzles. Edit content of the src/app/chat-window.component.ts and place following code inside:
{% c-block language="javascript" %}
import { Component, ViewChild, ElementRef } from '@angular/core';
import { CometChatService } from '../comet-chat.service';
import { Observable } from 'rxjs';
import { scan, map, filter, tap } from 'rxjs/operators';
@Component({
selector: 'app-chat-window',
templateUrl: './chat-window.component.html',
styleUrls: ['./chat-window.component.scss']
})
export class ChatWindowComponent {
public typingIndicator: Observable<boolean> = this.chatService.getTypingIndicator().pipe(map(val => val.length > 0));
public who: Observable<string> = this.chatService.getTypingIndicator().pipe(filter(val => val.length > 0), map(val => {
switch(val.length) {
case 1: return `${val[0]} is typing`;
case 2: return `${val[0]} and ${val[1]} are typing`;
default: return `Many poeple are typing`;
}
}));
public messages: Observable<any[]> = this.chatService.getMessages().pipe(
scan<any>((acc, curr) => [...acc, curr], [])
);
@ViewChild('conversation', { static: true })
private conversationContainer: ElementRef;
constructor(private chatService: CometChatService) {
}
public ngOnInit(): void {
this.messages.pipe(tap(() => {
this.conversationContainer.nativeElement.scrollTop = this.conversationContainer.nativeElement.scrollHeight;
})).subscribe();
}
}
{% c-block-end %}
Couple things went on here. First of all, you are retrieving the Observable with information about who is typing from the CometChatService ; later, basing on the number of typing users you are creating a new observable called who - that’s what you are going to display in the template. Last but not least observable is messages which is stream of messages sent by you and other users. For purpose of scrolling the chat window to the recent messages you are going to use conversationContainer the JavaScript scrollTop method is used inside the ngOnInit method (an Angular lifecycle hook).
Implement template which uses all of those methods and variables. Change content of the src/app/chat-window.component.html to the following:
{% c-block language="html" %}
<div class="conversation" #conversation>
<div *ngFor="let message of messages | async" [ngClass]="{'external': message.arrived, 'internal': !message.arrived}">
<img [src]=message.image />
<p><span *ngIf="message.name && message.arrived">{{message.name}}</span>{{message.message}}</p>
</div>
</div>
<div *ngIf="typingIndicator | async" class="typingIndicator">
<span>{{who | async}}
<div class="container">
<span class="dot"></span>
<span class="dot"></span>
<span class="dot"></span>
</div>
</span>
</div>
{% c-block-end %}
And finally, make the final touch by adjusting css in the src/app/chat-window.component.scss:
{% c-block language="markdown" %}
:host {
position: relative;
height: 385px;
display: block;
padding: 0 15px 0;
background: #F8F9FB;
}
div.conversation {
overflow: auto;
height: 350px;
padding-bottom: 35px;
div {
display: flex;
flex-direction: row;
align-items: flex-end;
}
div + div {
margin-top: 20px;
}
div:first-child {
margin-top: 15px;
}
div:last-child {
margin-bottom: 40px;
}
p {
span {
display: block;
font-weight: bold;
font-size: 12px;
color: #1B47DB;
}
padding: 15px;
border-radius: 12px;
font-size: 14px;
line-height: 19px;
margin: 0;
max-width: 250px;
}
.internal p {
background: #1B47DB;
color: white;
margin-right: 15px;
}
.external p {
background: #ffffff;
box-shadow: 0px 1px 2px rgba(189, 204, 215, 0.544307);
margin-left: 15px;
}
.internal {
flex-direction: row-reverse;
}
}
img {
height: 50px;
}
div.typingIndicator {
height: 35px;
color: #575A65;
font-size: 13px;
display: flex;
align-items: center;
position: absolute;
bottom: 0;
width: 100%;
background: #F8F9FB;
margin-left: -15px;
padding-left: 20px;
box-sizing: border-box;
}
.container {
display: inline-block;
position: relative;
top: -1px;
left: 3px;
}
.dot {
height: 4px;
width: 4px;
border-radius: 100%;
display: inline-block;
background-color: #5C5E69;
animation: 1.2s typing-dot ease-in-out infinite;
}
.dot:nth-of-type(2) {
animation-delay: 0.15s;
margin-left: 3px;
}
.dot:nth-of-type(3) {
animation-delay: 0.25s;
margin-left: 3px;
}
@keyframes typing-dot {
15% {
transform: translateY(-35%);
opacity: 0.5;
}
30% {
transform: translateY(0%);
opacity: 1;
}
}
@media (max-width: 450px) {
img {
display: none;
}
div.conversation .external p,
div.conversation .internal p {
margin-left: 0;
margin-right: 0;
}
}
{% c-block-end %}
Now, after navigating to localhost:4200 in two separate windows, authorizing into two different accounts, you should be able to perform a real-life test of the typing indicator:
If you haven't been coding along and want to catch up to this step using the companion repository on GitHub, execute the following commands in the directory where you’d like to create the project:
{% c-block %}
git clone https://github.com/maciejtreder/comet-chat-angular.git
cd comet-chat-angular
git checkout step2
npm install
{% c-block-end %}
Today you brought one of the most important part of human communication - voice and view - to the web! You learned how to embed CometChat in an Angular application.